<HTML>
<HEAD>
<TITLE>edit muwed entry</TITLE>
<?php

/*
 * edit.php - the script to edit/delete/create an song
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 */

chdir("..");
require_once("config.inc");

if($CSS_FILE!=false)
  echo("<LINK HREF=\"../$CSS_FILE\" TYPE=\"text/css\" REL=STYLESHEET>");

echo("
</HEAD>
<BODY>
<TABLE CELLSPACING=$TABLE_SPACING CELLPADDING=0 BORDER=$TABLE_BORDER WIDTH=\"$MAX_TABLE_WIDTH\" HEIGHT=\"$MAX_TABLE_HEIGHT\">
<TR><TD CLASS=Title VALIGN=TOP>
  <TABLE WIDTH=\"100%\">
    <TR><TD class=Name ALIGN=MIDDLE>edit muwed entry</TD></TR>
  </TABLE>
</TD></TR>");

$conn=pg_connect("host=$DBHOST user=$DBUSER dbname=$DBNAME");
if(!$conn)
{
  echo("<TR><TD CLASS=Navigation WIDTH=\"100%\" ALIGN=CENTER><B>Failed to open the database $DB_NAME at $DB_HOST for $DB_USER</TD></TR>");
}
else
{
  $fields="";
  $columns="";
  $values="";

  reset($HTTP_GET_VARS);
  while(list($key, $val)=each($HTTP_GET_VARS)) 
  {
    if($key != "id" && $key != "cmd")
    {
      if($fields != "")
        $fields.=", ";

      if($columns != "")
        $columns.=", ";

      if($values != "")
        $values.=", ";

      if($key=="flags" && strncmp($val, "0x", 2)==0)
        $val=hexdec($val);

      if($val == "")
        $val="NULL";
      else
        $val="'$val'";

      $fields.="$key=$val";
      $columns.="$key";
      $values.="$val";
    }
  }

  $err=false;
  $msg=false;
  if($cmd == "update")
  {
    $result=pg_exec($conn, "UPDATE songs SET $fields WHERE id=$id;");

    if($result == false)
      $msg="failed updating entry";
    else
      $msg="updated entry";
 
    $err=pg_errormessage($conn);
  }
  else if($cmd == "create")
  {
    $result=pg_exec($conn, "INSERT INTO songs ($columns) VALUES ($values);");

    if($result == false)
      $msg="failed creating new entry";
    else
    {
      $msg="created new entry";

      $oid=pg_getlastoid($result);
      $result=pg_exec($conn, "SELECT id FROM songs WHERE oid=$oid;");
      
      $ida=pg_fetch_array($result, 0);
      $id=$ida[0];
    }

    $err=pg_errormessage($conn);
  }
  else if($cmd == "delete")
  {
    $result=pg_exec($conn, "DELETE FROM songs WHERE id=$id;");

    if($result == false)
      $msg="failed deleting entry";
    else
      $msg="deleted entry";

    $err=pg_errormessage($conn);
  }
 
  if($msg!=false)
  {
    if($err!=false)
      $err="<BR>".$err;

    echo("<TR><TD CLASS=Navigation ALIGN=CENTER><B>$msg</B>$err</TD></TR>");
  }

  $result=pg_exec($conn,"SELECT * FROM songs WHERE id=$id;");

  $entries_found=pg_numrows($result);
  
  if($entries_found > 0)
  {
    // let's create the update form
    $song=pg_fetch_array($result, 0);

    echo("
<FORM NAME=\"updateform\" ACTION=\"edit.php\" METHOD=GET>
<INPUT TYPE=HIDDEN NAME=\"id\" VALUE=\"$id\">
<TR><TD CLASS=Content VALIGN=TOP HEIGHT=\"100%\">
<TABLE CELLSPACING=4 CELLPADDING=0 BORDER=$TABLE_BORDER WIDTH=\"100%\">
<TR><TD CLASS=Column ALIGN=CENTER WIDTH=\"50%\"><B>Field:</B></TD><TD CLASS=Column ALIGN=CENTER><B>Value:</B></TD></TR>
");

    for($i=0; $i<pg_numfields($result); $i++)
    {
      $name=pg_fieldname($result, $i);
      $uname=ucfirst($name);

      if($name=="flags")
        $val=sprintf("0x%08X", $song[$i]);
      else
        $val=$song[$i];
      $val=htmlspecialchars($val);

      if($name != "id")
      {
        echo("<TR><TD CLASS=Entry ALIGN=LEFT><B>$uname:</B></TD><TD CLASS=Entry ALIGN=LEFT><INPUT TYPE=TEXT SIZE=$EDIT_SIZE NAME=\"$name\" VALUE=\"$val\"></TD></TR>\n");
      }
    }

    echo("
</TABLE>
<TR><TD CLASS=Title VALIGN=TOP>
<TABLE WIDTH=\"100%\">
<TR>
  <TD CLASS=Name ALIGN=CENTER><INPUT TYPE=SUBMIT NAME=\"cmd\" VALUE=\"update\"></TD>
  <TD CLASS=Name ALIGN=CENTER><INPUT TYPE=SUBMIT NAME=\"cmd\" VALUE=\"create\"></TD>
  <TD CLASS=Name ALIGN=CENTER><INPUT TYPE=SUBMIT NAME=\"cmd\" VALUE=\"delete\"></TD>
  <TD CLASS=Name ALIGN=CENTER><INPUT TYPE=RESET VALUE=\"reset\"></TD>
</TR>");

    if($HAS_JS) 
      echo("<TR><TD class=Name ALIGN=CENTER COLSPAN=4>[<A HREF=\"javascript:window.close()\">close</A>]</TD></TR>");

    echo("
</TABLE>
</TD></TR>
</FORM>");
  }
  else if($HAS_JS)
  {
    echo("
<TR><TD CLASS=Title VALIGN=TOP>
  <TABLE WIDTH=\"100%\">
    <TR><TD class=Name ALIGN=MIDDLE>[<A HREF=\"javascript:window.close()\">close</A>]</TD></TR>
  </TABLE>
</TD></TR>");
  }
}

?>
</TABLE>
</BODY>
</HTML>

