<?php

/* 
 * config.inc - the main config file for muwed
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 * all configurations for muwed should be placed here.
 * please edit it, so that it matches you configuration. 
 * 
 */

require_once("browsers.inc");

/* the number of entries displayed on one page
 */
$MAX_ENTRIES=20;

/* show composer in search results and allow searching ?
 */
$SHOW_COMPOSER=false;

/* the root dir for mp3 files (where in the local file system
 * are the mp3 files located
 */
$MP3ROOT="/scratch3/mp3/";

/* the root for the links to the files 
 * where on the web server are you mp3 files located (e.g. "/music"
 * for a virtual directory called music pointing to $MP3ROOT)
 */
$LINKROOT="file://apollo/root$MP3ROOT";

/* the location of the getAPIC perl script (used to extract
 * pictures from ID3v2 APIC frames)
 */
$GETAPIC="/cgi-bin/getAPIC.pl?file=";

/* the host and port of you irmp3 server
 */
$IRMP3_HOST="localhost";
$IRMP3_PORT="9232";


/* the name of the database server
 */
$DBHOST="localhost";

/* the name of the database user
 */
$DBUSER="postgres";

/* the name of the database itself
 */
$DBNAME="muwed";

?>

